##Minicurso R - UFPR 

rm(list=ls(all=TRUE)) 

##Pacote qcc

##Grfico de controle para variveis - Exemplo 1

library(qcc)
data(pistonrings)
head(pistonrings)

## Agrupar os dados

attach(pistonrings)
diameter<-qcc.groups(diameter,sample)
head(diameter)

##Construir o grfico

qcc(diameter[1:25,],type="xbar")

##Grfico para Amplitude

qcc(diameter[1:25,],type="R")

##Grfico S

qcc(diameter[1:25,],type="S")

##Fase II

qcc(diameter[1:25,],newdata=diameter[26:40,],type="xbar")

##Grfico de amplitude

qcc(diameter[1:25,],newdata=diameter[26:40,],type="R")

##Grfico S

qcc(diameter[1:25,],newdata=diameter[26:40,],type="S")
detach(pistonrings)

##Exerccio 1 - dados umidade

library(readxl)
exercicio_1 <- read_excel("C:/Users/elisa/Dropbox/apresentacoes/exercicio_1.xlsx")
head(exercicio_1)
attach(exercicio_1)

##Construir o grfico

umid<-qcc.groups(umidade,amostra)
umid
qcc(umid,type="xbar")

##Grficos R e S

qcc(umid,type="R")
qcc(umid,type="S")
detach(exercicio_1)

##Grfico para medidas individuais - Exemplo 2- viscosity data (Montgomery, pag. 242)

x <- c(33.75, 33.05, 34, 33.81, 33.46,34.02, 33.68, 33.27, 33.49, 33.20,33.62, 33.00, 33.54, 33.12, 33.84)   
qcc(x, type="xbar.one")
qcc(x, type="xbar.one", std.dev = "SD")
remove(x)

##Exerccio 2 

exercicio_2 <- read_excel("C:/Users/elisa/Dropbox/apresentacoes/exercicio_2.xlsx")
head(exercicio_2)
attach(exercicio_2)
qcc(diametro,type="xbar.one")
detach(exercicio_2)

##Grfico para atributos

##Grfico p e np - Exemplo 3

data(orangejuice)
head(orangejuice)
attach(orangejuice)
qcc(D[trial], sizes=size[trial], type="p")

## Remover pontos alm dos limites de controle estatstico 
inc <- setdiff(which(trial), c(15,23))
q1 <- qcc(D[inc], sizes=size[inc], type="p")
qcc(D[inc], sizes=size[inc], type="p", newdata=D[!trial], newsizes=size[!trial]) 
detach(orangejuice)


##Exerccio 3

exercicio_3 <- read_excel("C:/Users/elisa/Dropbox/apresentacoes/exercicio_3.xlsx")
head(exercicio_3)
attach(exercicio_3)

##Grfico p 

qcc(d,type="p",sizes=tamanho)
qcc(d,type="np",sizes=tamanho)
detach(exercicio_3)


##Grafico c - No conformidades - Exemplo 4

data(circuit)
attach(circuit)

qcc(x[trial], sizes=size[trial], type="c")
inc <- setdiff(which(trial), c(6,20))
qcc(x[inc], sizes=size[inc], type="c")

##Fase 2


qcc(x[inc], sizes=size[inc], type="c", newdata=x[!trial], newsizes=size[!trial], newlabels=which(!trial))
detach(circuit)

##Exercicio 4

exercicio_4 <- read_excel("C:/Users/elisa/Dropbox/apresentacoes/exercicio_4.xlsx")
attach(exercicio_4)
head(exercicio_4)
qcc(c,type="c",sizes=tamanho)
detach(exercicio_4)

##Grafico u - Exemplo 5

data(pcmanufact)
attach(pcmanufact)
qcc(x, sizes=size, type="u")
detach(pcmanufact)

##Exercicio 5

attach(exercicio_4)
qcc(c,type="u",sizes=tamanho)
detach(exercicio_4)

##Grficos de Soma Acumulada - CUSUM - Exemplo 6

data(pistonrings)
attach(pistonrings)
diameter <- qcc.groups(diameter, sample)
q <- cusum(diameter[1:25,], decision.interval = 4, se.shift = 1)

summary(q)
q <- cusum(diameter[1:25,], newdata=diameter[26:40,])
summary(q)
plot(q, chart.all=FALSE)

##Exercicio adicional - dados do exerccio 2

attach(exercicio_2)
cusum(diametro)

##Grfico de Mdia Mvel Exponencialmente Ponderada - Exemplo 7
v <- c(33.75, 33.05, 34, 33.81, 33.46, 34.02, 33.68, 33.27, 33.49, 33.20,33.62, 33.00, 33.54, 33.12, 33.84) 
q <-  ewma(v, lambda=0.2, nsigmas=2.7)


##Exerccio adicional - dados do exercicio 2

ewma(diametro)


##Anlise da Capacidade de Processos

# Exemplo 8 - pistonrings

data(pistonrings) 
attach(pistonrings) 
diameter <- qcc.groups(diameter, sample) 
q1<- qcc(diameter[1:25,], type="xbar", nsigmas=3, plot=FALSE) 
process.capability(q1, spec.limits=c(73.95,74.05)) 
process.capability(q1, spec.limits=c(73.95,74.05), target=74.02)
detach(pistonrings)

##Exerccio 8

exercicio_6 <- read_excel("C:/Users/elisa/Dropbox/apresentacoes/exercicio_7.xlsx")
head(exercicio_6)
attach(exercicio_6)
largura<-qcc.groups(Largura,Amostra)
q1<-qcc(largura,type="xbar")
process.capability(q1,spec.limits=c(20,100))

##Outras ferramentas do CEP

##Grafico de Pareto - Exemplo 9

automoveis<-c(4,4,6,21,8,5,30,3) 
names(automoveis)<-c("arranhes","buracos","fora da sequencia","subaparadas", "fendas perdidas", "no lubrificadas", "fora de contorno", "rebarbas")
pareto.chart(automoveis, main="Pareto das portas dos automveis", col=rainbow(8))

##Grfico de Causa e efeitos - Exemplo 10

cause.and.effect(cause=list(Measurements=c("Micrometers", "Microscopes", "Inspectors"),
                            Materials=c("Alloys", "Lubricants", "Suppliers"),
                            Personnel=c("Shofts", "Supervisors", "Training", "Operators"),
                            Environment=c("Condensation", "Moisture"),
                            Methods=c("Brake", "Engager", "Angle"),
                            Machines=c("Speed", "Lathes", "Bits", "Sockets")),
                 effect="Surface Flaws")

##graficos multivariados
##grafico multivariado T2 de Hotelling - Exemplo 11

data(boiler)
head(boiler)
q = mqcc(boiler, type = "T2.single", confidence.level = 0.999)
summary(q)
library(MASS)
boilerNew = mvrnorm(10, mu = q$center, Sigma = q$cov)
qq = mqcc(boiler, type = "T2.single", confidence.level = 0.999, newdata = boilerNew, pred.limits = TRUE)


##MSQC - pacote para graficos multivariados

##Exemplo 13

library(MSQC)
#Fase I
data(carbon1)
mult.chart(type = "t2", carbon1)

#Phase II
Xmv <- mult.chart(carbon1, type = "t2") $Xmv
S <- mult.chart(carbon1, type = "t2") $covariance

data(carbon2)
mult.chart(carbon2, type = "t2", Xmv = Xmv, S = S)

Xmv <- mult.chart(carbon1, type = "t2") $Xmv
S <- mult.chart(carbon1, type = "t2") $covariance

## MEWMA - Exemplo 14
mult.chart(type = "mewma", carbon2, Xmv = Xmv, S = S)


#Multivariate Cumulative Sum (MCUSUM) in Phase I - Exemplo adicional
mult.chart(type = "mcusum", carbon2)
mult.chart(type = "mcusum2", carbon2)

##NORMALIDADE MULTIVARIADA - Exemplo 15

data("bimetal1")
MardiaTest(bimetal1)



